//Robo Cup  LogMonitor 
// This Program is developed based on Noda Itsuki's  sserver-3.28.
import java.awt.*;
import java.net.*;
import java.io.*;
import java.awt.event.*;
import java.util.*;
//
//default main window
//
public class MainWindow extends Frame implements WindowListener{

	FileOutputStream fo ;
	PrintWriter fop ;


	PlayerWin pw;
	MenuBar	menubar;
	Menu	menuFile;
	Menu	menuWindow;
	Menu	menuOption;
	MenuItem	menuItemOpenFile;
	MenuItem	menuItemQuit;
	MenuItem	menuItemPlayers;
	MenuItem	menuItemKick;
	CheckboxMenuItem	menuItemWait;
	Button 	btnQuit, btnKickOff;
	Button  btnDijest;
	Button	btnConnect;	
	Button	btnDraw;
	Button  btnPause;

	List	Msg_board ;			/* message board */
	List	Log_board ;			/* log board */

	TextField	status_l ;		/* for left team */
	TextField	status_r ;		/* for right team */
	Label		status_t ;		/* to display time */
	Label		status_m ;		/* to display play mode */
	Label		goalscore_l ;
	Label		goalscore_r ;
	Label		dummyField1;
	Label		dummyField2;
	Label		dummyField3;
	Label		dummyField4;
	Panel 		headerPanel;
	Panel 		msgPanel;

	CField 		field;
	CPort           port;	

	protected String logName;

	String teamNameL, teamNameR;

	static Color color_r = Color.blue; 
	static Color color_l = Color.red;
	static int board_rows = 6;
		
	Analyze ana; 
	MainWindow(){

		super("java soccermonitor");
		pw = new PlayerWin();
		ana = new Analyze();
		init();		
	}
	void init(){
		//t[̐ݒ
		this.setLayout(new BorderLayout());
		this.setBackground(Color.white);

		//Creating Panel of menu bar & buttons & textField.

		createMenuBar();
		
		createHeaderPanel();

		createField();
		
		Dimension d = new Dimension();
		d = field.getSize();

		setSize( d.width, d.height);

		addWindowListener(this);

	}	

	public void setLogName(String logName){
		this.logName = logName;
	}

	public MainWindow getMainWindow(){
		return this;
	}

	public void fileEnd(){

		int pass = 0;
		int passMiss = 0;
		int drible = 0;


		//NbNł{^̃Zbg
		btnKickOff.setEnabled(false);
		btnDijest .setEnabled(false);
		btnQuit   .setEnabled(false);
		btnPause  .setEnabled(false);

		SaveFileDialog sfd = new SaveFileDialog(this, true);
		sfd.open();
				
		sfd.dispose();
		port.stop();
	
		
		}	
	public void saveInfo(String filename){

		int pass = 0;
		int passCut = 0;
		int drible = 0;	

		try{
			fo = new FileOutputStream(filename);
                	fop = new PrintWriter(fo);               

	        fop.println("Total LEFT TEAM ("+port.rInfo.getTeamName(CParam.CType_LEFT).trim()+")RESULT");
		
		fop.println("SCORE = "+port.rInfo.getScore(0));
		fop.println("Off side = "+ana.offSide_l);
		fop.println("Kick count = "+ port.rInfo.getTeamKickCount(CParam.CType_LEFT));
		fop.println("Runnig distance"+port.rInfo.getTeamDistance(CParam.CType_LEFT));

		fop.println("Ball control rate = "+(int)(ana.shihaiLeft/(double)(ana.play_on_time)*100)+"%");  

		
		for(int i = 0; i<= 10 ;++i){
			pass += ana.player[i].pass;
			passCut += ana.player[i].passCut;
			drible	 += ana.player[i].dribble;
		}
		fop.println("Success pass = "+pass);
		fop.println("Intercept = "+passCut);
		fop.println("Dribble  = "+drible);
		pass = passCut = drible = 0;

		fop.println("Total RIGHT TEAM ("+port.rInfo.getTeamName(CParam.CType_RIGHT).trim()+")RESULT");
		fop.println("SCORE = "+port.rInfo.getScore(1));
		fop.println("Off side = "+ana.offSide_r);
		fop.println("Kick count = "+ port.rInfo.getTeamKickCount(CParam.CType_RIGHT));
		fop.println("Runnig distance"+port.rInfo.getTeamDistance(CParam.CType_RIGHT));

		fop.println("Ball Control rate = "+(int)(ana.shihaiRight/(double)(ana.play_on_time)*100)+"%");  

		for(int i = 11; i<= 21 ;++i){
			pass += ana.player[i].pass;
			passCut += ana.player[i].passCut;
			drible	 += ana.player[i].dribble;
		}

		fop.println("Success pass = "+pass);
		fop.println("Intercept  = "+passCut);
		fop.println("Dribble  = "+drible);
		fop.close();
		}catch(IOException e){
			System.err.println(e);
		}
	fo = null;	
	fop = null;
	}
	public void update(ReplayInfo rInfo){

		status_l.setText(rInfo.getTeamName(CParam.CType_LEFT).trim()+":"+rInfo.getScore(0));
		status_r.setText(rInfo.getTeamName(CParam.CType_RIGHT).trim()+":"+rInfo.getScore(1));
		status_t.setText(new Integer(rInfo.getTime()).toString());
		status_m.setText(rInfo.getPlayMode());
		ana.setBallVelo(rInfo.getTime(),rInfo.getCBall().getVelo());
		ana.setKickMember(rInfo.getTime(), rInfo.getKickMember());
		ana.setPlayMode(rInfo.getPlayMode());
		ana.analyze();		

		pw.setReplayInfo(rInfo);
		field.setReplayInfo(rInfo);
		field.repaint();
		
	}

	private void createMenuBar(){

		menubar = new MenuBar();
		this.setMenuBar(menubar);
		menuFile = new Menu("File");
		menuWindow = new Menu("Window");
		menuOption = new Menu("Option");
		menuItemOpenFile = new MenuItem("Open Log File...");
		menuItemQuit     = new MenuItem("Quit...");
		
		menuFile.add(menuItemOpenFile);
		menuFile.add(menuItemQuit);
		menubar.add(menuFile);
		
		menuItemPlayers = new MenuItem("Players Information...");
		menuItemKick    = new MenuItem("Kick Result...");
		menuWindow.add(menuItemPlayers);
		menuWindow.add(menuItemKick);
		menubar.add(menuWindow);
		menuItemWait = new CheckboxMenuItem("Wait ON");
		menuOption.add(menuItemWait); 
		menubar.add(menuOption);
		//ANVXiւ̓o^
		OpenFileAdapter ofa = new OpenFileAdapter(this);
		menuItemOpenFile.addActionListener(ofa);
		MenubarAdapter menuAdap = new MenubarAdapter();
		menuItemQuit.addActionListener(menuAdap);
		menuItemPlayers.addActionListener(menuAdap);
		menuItemKick.addActionListener(menuAdap);
		menuItemWait.addActionListener(menuAdap);
		}

	private void createHeaderPanel(){

		headerPanel = new Panel();
		headerPanel.setLayout(new GridLayout(2,6));
		status_l = new TextField("Team_L");
        	status_l.setEditable(false);
        	status_l.setBackground(color_l);
		status_r = new TextField("Team_R");
        	status_r.setEditable(false);
        	status_r.setBackground(color_r);
		status_t = new Label("00000");
		status_t.setAlignment(status_t.CENTER);
		status_m = new Label("before_kick_off");
		status_m.setAlignment(status_m.CENTER);		
		goalscore_l = new Label(" ");
		goalscore_r = new Label(" ");
		dummyField1 = new Label("      ");
		dummyField2 = new Label("      ");
		dummyField3 = new Label("      ");
	        dummyField4 = new Label("      ");
		btnQuit = new Button("Stop");
		btnKickOff = new Button("Kick-Off");
		btnDijest  = new Button("Dijest");
		btnPause   = new Button("Pause");
		teamNameL = new String("Team_L");
		teamNameR = new String("Team_R");
		btnKickOff.setEnabled(false);
		btnDijest .setEnabled(false);
		btnQuit.setEnabled(false);
		btnPause.setEnabled(false);
		msgPanel = new Panel();
		msgPanel.setLayout(new GridLayout(1,2));
		Msg_board = new List(board_rows, false);
		Log_board = new List(board_rows, false);
		headerPanel.add(btnKickOff);
		headerPanel.add(btnDijest);
		
	//	headerPanel.add(dummyField2);
		headerPanel.add(dummyField3);
		headerPanel.add(dummyField4);
		headerPanel.add(btnQuit);
		headerPanel.add(btnPause);

		//{^̃ANVXiւ̓o^
		ButtonAdapter buttonAdap = new ButtonAdapter();
		btnKickOff.addActionListener(buttonAdap);
		btnDijest.addActionListener(buttonAdap);
		btnQuit.addActionListener(buttonAdap);
		btnPause.addActionListener(buttonAdap);

		// lower
		headerPanel.add(status_l);
		headerPanel.add(goalscore_l);
		headerPanel.add(status_m);
		headerPanel.add(status_t);
		headerPanel.add(goalscore_r);
		headerPanel.add(status_r);
		// Adding field to this applet.
		this.add("North",headerPanel);
       		}

	private void createField(){
		field = new CField();
		this.add("Center", field);
	}		
	
	public void windowClosed(WindowEvent event) {
    	}
   	public void windowDeiconified(WindowEvent event) {
   	}
   	public void windowIconified(WindowEvent event) {
   	}
   	public void windowActivated(WindowEvent event) {
   	}
   	public void windowDeactivated(WindowEvent event) {
   	}
   	public void windowOpened(WindowEvent event) {
   	}
   	public void windowClosing(WindowEvent event) {
           System.exit(0);
   	}	
	//j[o[̃Cxĝ߂̃Ci[NX
	class MenubarAdapter implements ActionListener{
		public void actionPerformed(ActionEvent e){
			Object source = e.getSource();
			System.out.println("menuItemWait1");
			if (source == menuItemQuit){
				System.exit(0);
			}
			else if (source == menuItemPlayers){
				pw.showWindow();
			}
			else if (source == menuItemKick){
			
				ana.showWindow();
			}
			else if (source == menuItemWait){
				System.out.println("menuItemWait");
				System.out.println(menuItemWait.getState());
				if (menuItemWait.getState() == false){
					port.setWaitTime(1000); 				
				}
				else { port.setWaitTime(1);}
			}
		}
	}			
	//{^̃Cxĝ߂̃Ci[NX
	class ButtonAdapter implements ActionListener {
		
		public void actionPerformed(ActionEvent e){

			Object source = e.getSource();

			if (source == btnKickOff){
			
				port = new CPort(getMainWindow());
				port.setFilename(logName);
				port.open();
				System.out.println("logName = "+logName);
 				port.start();

				btnKickOff.setEnabled(false);
				btnDijest .setEnabled(false);
				btnQuit   .setEnabled(true);
				btnPause  .setEnabled(true);
		}

			else if (source == btnDijest){

				System.out.println("Dijest pushed");
			}
	
			else if (source == btnQuit){
				btnKickOff.setEnabled(false);
				btnDijest .setEnabled(false);
				btnQuit   .setEnabled(false);
				btnPause  .setEnabled(false);
			
				port.stop();
			//	ana = new Analyze(3000);
			//	pw = new PlayerWin();
				
			/*
				for (int i = 0; i <= 21; ++i){
					
					System.out.println("player["+i+"] kicked "+port.rInfo.getPlayerKickCount(i)+" run "+port.rInfo.getPlayerDistance(i));
			
				}
			*/
				port = null;
			}
			else if (source == btnPause){

				if (btnPause.getLabel() == "Pause"){
					port.suspend();
					btnPause.setLabel("Restart");
				}
				else if (btnPause.getLabel() == "Restart"){
					port.resume();
					btnPause.setLabel("Pause");

				}
			}

		}	
	}
}


	















